//=============================================================================
//
// file :         InterferometerClass.h
//
// description :  Include for the InterferometerClass root class.
//                This class is the singleton class for
//                the Interferometer device class.
//                It contains all properties and methods which the 
//                Interferometer requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// SVN only:
// $HeadURL: $
//
// CVS only:
// $Source:  $
// $Log:  $
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _INTERFEROMETERCLASS_H
#define _INTERFEROMETERCLASS_H

#include <tango.h>
#include <Interferometer.h>


namespace Interferometer_ns
{//=====================================
//	Define classes for attributes
//=====================================
class samplesAttrib: public Tango::SpectrumAttr
{
public:
	samplesAttrib():SpectrumAttr("samples", Tango::DEV_DOUBLE, Tango::READ, 100000) {};
	~samplesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Interferometer *>(dev))->read_samples(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Interferometer *>(dev))->is_samples_allowed(ty);}
};

class standardDeviationAttrib: public Tango::Attr
{
public:
	standardDeviationAttrib():Attr("standardDeviation", Tango::DEV_DOUBLE, Tango::READ) {};
	~standardDeviationAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Interferometer *>(dev))->read_standardDeviation(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Interferometer *>(dev))->is_standardDeviation_allowed(ty);}
};

class angleConvAttrib: public Tango::Attr
{
public:
	angleConvAttrib():Attr("angleConv", Tango::DEV_DOUBLE, Tango::READ) {};
	~angleConvAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Interferometer *>(dev))->read_angleConv(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Interferometer *>(dev))->is_angleConv_allowed(ty);}
};

class negValuesAttrib: public Tango::Attr
{
public:
	negValuesAttrib():Attr("negValues", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~negValuesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Interferometer *>(dev))->read_negValues(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Interferometer *>(dev))->write_negValues(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Interferometer *>(dev))->is_negValues_allowed(ty);}
};

class samplesQuantityAttrib: public Tango::Attr
{
public:
	samplesQuantityAttrib():Attr("samplesQuantity", Tango::DEV_DOUBLE, Tango::READ) {};
	~samplesQuantityAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Interferometer *>(dev))->read_samplesQuantity(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Interferometer *>(dev))->is_samplesQuantity_allowed(ty);}
};

class beamStrengthAttrib: public Tango::Attr
{
public:
	beamStrengthAttrib():Attr("beamStrength", Tango::DEV_DOUBLE, Tango::READ) {};
	~beamStrengthAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Interferometer *>(dev))->read_beamStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Interferometer *>(dev))->is_beamStrength_allowed(ty);}
};

class averageAttrib: public Tango::Attr
{
public:
	averageAttrib():Attr("average", Tango::DEV_DOUBLE, Tango::READ) {};
	~averageAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Interferometer *>(dev))->read_average(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Interferometer *>(dev))->is_average_allowed(ty);}
};

class frequencyAttrib: public Tango::Attr
{
public:
	frequencyAttrib():Attr("frequency", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~frequencyAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Interferometer *>(dev))->read_frequency(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Interferometer *>(dev))->write_frequency(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Interferometer *>(dev))->is_frequency_allowed(ty);}
};

class integrationTimeAttrib: public Tango::Attr
{
public:
	integrationTimeAttrib():Attr("integrationTime", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~integrationTimeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<Interferometer *>(dev))->read_integrationTime(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<Interferometer *>(dev))->write_integrationTime(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<Interferometer *>(dev))->is_integrationTime_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class StopClass : public Tango::Command
{
public:
	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Interferometer *>(dev))->is_Stop_allowed(any);}
};



class StartClass : public Tango::Command
{
public:
	StartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Interferometer *>(dev))->is_Start_allowed(any);}
};



class ResetCmd : public Tango::Command
{
public:
	ResetCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Interferometer *>(dev))->is_Reset_allowed(any);}
};



//
// The InterferometerClass singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	InterferometerClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static InterferometerClass *init(const char *);
	static InterferometerClass *instance();
	~InterferometerClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	InterferometerClass(string &);
	static InterferometerClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace Interferometer_ns

#endif // _INTERFEROMETERCLASS_H
